<template>
  <div>
    <Drawer
      :title="formTitle"
      v-model="modalVisible"
      width="720"
      :mask-closable="false"
      :styles="styles"
      @on-close="close"
    >
      <Form
        ref="formValidate"
        :model="formValidate"
        :rules="ruleValidate"
        :label-width="150"
        v-if="formValidate.details"
      >
       <FormItem label="关联条目">
           <Cascader :data="treeData" v-model="formValidate.ancestors"></Cascader>
        </FormItem>
        <FormItem label="板块名称" prop="details.name">
           <Input
            v-model="formValidate.details.name"
            placeholder="Enter something"
          ></Input>
        </FormItem>
        <FormItem label="简介" prop="details.summary">
          <Input
           type="textarea"
            v-model="formValidate.details.summary"
            placeholder="请输入内容"
          ></Input>
        </FormItem>
      </Form>
      <div class="demo-drawer-footer">
        <Button style="margin-right: 8px" @click="close">取消</Button>
        <Button type="primary" @click="submit">保存</Button>
      </div>
    </Drawer>
  </div>
</template>
<script>
import UploadS from '@/view/common/upload.vue'
import {
  addSections,
  editSections
} from '@/api/sections'
import {
  getTreeCategories
} from '@/api/categories'
const _requireBlur = { required: true, message: ' ', trigger: 'blur' }
const validatorPic = (rule, value, callback) => {
  if (!value) {
    callback(new Error(' '))
  } else {
    callback()
  }
}
const _requirePic = { required: true, message: ' ', trigger: 'blur', validator: validatorPic }
export default {
  props: {
    search: {
      type: Function,
      default: null
    },
    treeData: {
      type: Array,
      default: () => []
    },
    row: {
      type: Object,
      default: () => {}
    },
    visible: {
      type: Boolean,
      default: false
    }
  },
  components: {
    UploadS
  },
  data () {
    return {
      modalVisible: false,
      editMode: false,
      formTitle: '',
      styles: {
        height: 'calc(100% - 55px)',
        overflow: 'auto',
        paddingBottom: '53px',
        position: 'static'
      },
      formValidate: {},
      ruleValidate: {
        'details.name': [_requireBlur],
        'details.summary': [_requireBlur],
        'details.res_home_background_pic': [_requirePic],
        'details.res_discover_list_pic': [_requirePic]
      }
    }
  },
  watch: {
    visible: {
      handler: function (val) {
        this.modalVisible = val
        if (val) {
          this.search()
        }
        this.formValidate = this.row
      },
      immediate: true
    },
    row: {
      handler: function (val) {
        console.log(val)
        if (val.id === 'add') {
          this.editMode = false
          this.formTitle = '新增板块'
          this.formValidate = {
            details: {
              name: '',
              summary: ''
            },
            ancestors: [],
            course_id: 1
          }
        } else {
          this.editMode = true
          this.formTitle = '编辑板块'
          this.formValidate = val
        }
      },
      immediate: true
    }
  },
  methods: {
    submit () {
      this.$refs['formValidate'].validate((valid) => {
        if (valid) {
          delete this.formValidate.created_at
          delete this.formValidate.deleted_at
          delete this.formValidate.updated_at
          if (this.formValidate.ancestors.length > 0) {
            this.formValidate.course_id = this.formValidate.ancestors[1]
          }
          let params = [this.formValidate]
          if (this.editMode) {
            editSections(params).then((res) => {
              if (res.code === 200 && res.data.length > 0) {
                this.$Message.success('修改成功')
                this.close()
                this.search()
              }
            })
          } else {
            addSections(params).then((res) => {
              if (res.code === 200 && res.data.length > 0) {
                this.$Message.success('新增成功')
                this.close()
                this.search()
              }
            })
          }
        } else {
          this.$Message.error('您还有必填项未填写')
        }
      })
    },
    getTree (e) {
      getTreeCategories(e).then((res) => {
        console.log(res)
      })
    },
    change (val, type) {
      if (type === 1) {
        this.formValidate.is_in_home_lis = val ? 1 : 0
      }
      if (type === 2) {
        this.formValidate.is_in_discover_list = val ? 1 : 0
      }
    },
    close () {
      this.$emit('update:visible', false)
    }
  }
}
</script>
<style>
.demo-drawer-footer {
  width: 100%;
  position: absolute;
  bottom: 0;
  left: 0;
  border-top: 1px solid #e8e8e8;
  padding: 10px 16px;
  text-align: right;
  background: #fff;
}
</style>
